{-# LANGUAGE NoImplicitPrelude, GADTs, KindSignatures #-}
module Main where
import qualified GHC.Show as Show
import qualified System.IO as IO
import qualified Unsafe.Coerce as Coerce
 
import Data.List
import Prelude hiding (Either, gcd)

data Nat :: * where
        DATA_zero :: Nat
        DATA_suc :: Nat -> Nat
    deriving Show.Show
 
data Either :: * where
        DATA_left :: Nat -> Either
        DATA_right :: Nat -> Either
    deriving Show.Show
 
esuc :: Either -> Either
esuc (DATA_left n) = DATA_left (DATA_suc n)
esuc (DATA_right n) = DATA_right (DATA_suc n)
 
minus :: Nat -> Nat -> Either
minus DATA_zero m = DATA_right m
minus (DATA_suc n) DATA_zero = DATA_left (DATA_suc n)
minus (DATA_suc n) (DATA_suc m) = minus n m
 
gcd :: Nat -> Nat -> Nat
gcd DATA_zero m = m
gcd (DATA_suc n) DATA_zero = DATA_suc n
gcd (DATA_suc n) (DATA_suc m) = gcd_aux n m (minus n m)
 
gcd_aux :: Nat -> Nat -> Either -> Nat
gcd_aux n m (DATA_left n') = gcd n' (DATA_suc m)
gcd_aux n m (DATA_right m') = gcd (DATA_suc n) m'
 
main :: IO.IO ()
main = IO.putStrLn "Hello, world!"

-- fromInt :: Int -> Nat
fromInt n = iterate DATA_suc DATA_zero !! n

toInt (DATA_zero) = 0
toInt (DATA_suc n) = toInt n + 1

test2  = toInt (gcd (fromInt 6) (fromInt 4))
test2' = toInt (gcd (fromInt 46) (fromInt 34))
test3  = toInt (gcd (fromInt 45) (fromInt 33))
