-- 2012-03-07 chat with Nicolai Kraus

data Id (A : Set) (a : A) : A -> Set
{ refl : Id A a a
}

check
fun subst : [A : Set] [a, b : A] [q : Id A a b]
            [P : A -> Set] -> P a -> P b
{ subst A a .a refl P h = h
}

-- Id elimination
fun J : [A : Set] [P : (a,b : A) -> Id A a b -> Set]
  (h : (a : A) -> P a a refl) (a,b : A) [q : Id A a b] -> P a b q
{ J A P h a .a refl = h a
}

-- Nicolai suggest the reduction rule
--
-- J A P h a b q = h a  if  P a b q = P a a refl (definitionally)

-- defining subst from J
let subst [A : Set] (a, b : A) (q : Id A a b)
          [P : A -> Set] : P a -> P b
  = J A (\ x y p -> P x -> P y) (\ y p -> p) a b q

-- extensionality axiom
fun ext : [A : Set] [B : A -> Set] [f, g : (x : A) -> B x]
  (h : (x : A) -> Id (B x) (f x) (g x)) ->
  Id ((x : A) -> B x) f g {}

-- The question is whether we get non-canonical terms with
-- ext and Nicolai's rule

let DEq [A : Set] (a, b : A) (p : Id A a b)
        (P : A -> Set) (x : P a) (y : P b) : Set
  = Id (P b) (subst A a b p P x) y

data Bool { true; false }

let id (x : Bool) = x
let BB = Bool -> Bool

fun not : BB
{ not true = false
; not false = true
}

let notnot (x : Bool) = not (not x)

fun notNotIdx : (x : Bool) -> Id Bool x (not (not x))
{ notNotIdx true = refl
; notNotIdx false = refl
}

let notNotId : Id BB id notnot
  = ext Bool (\ x -> Bool) id notnot notNotIdx

fun T : Bool -> Set
{ T true  = Bool
; T false = Bool -> Bool
}

let P (f : BB) = T (f false)

fail
let nni : DEq BB id notnot notNotId P id notnot = notNotId
